/*
* Copyright (c) 2004-2006 Weswit s.r.l., Via Campanini, 6 - 20124 Milano, Italy.
* All rights reserved.
* www.lightstreamer.com
*
* This software is the confidential and proprietary information of
* Weswit s.r.l.
* You shall not disclose such Confidential Information and shall use it
* only in accordance with the terms of the license agreement you entered
* into with Weswit s.r.l.
*/

using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;

using Lightstreamer.DotNet.Client;

namespace Nms.DotNet.Client.Demo {

    class NmsClient {
        private DemoForm demoForm;
        private LightstreamerUpdateDelegate updateDelegate;
        private LightstreamerStatusChangedDelegate statusChangeDelegate;

        private LSClient client;

        public NmsClient(
                DemoForm form,
                LightstreamerUpdateDelegate lsUpdateDelegate,
                LightstreamerStatusChangedDelegate lsStatusChangeDelegate) {
            
            demoForm = form;
            updateDelegate = lsUpdateDelegate;
            statusChangeDelegate = lsStatusChangeDelegate;

            client = new LSClient();
        }
        
        public void Stop() {
            client.CloseConnection();
        }

        public void Start(string pushServerUrl) {
            ConnectionInfo connInfo = new ConnectionInfo();
            connInfo.pushServerUrl = pushServerUrl;
            connInfo.adapter = "NMSTEST";

            client.OpenConnection(
                connInfo, 
                new NmsConnectionListener(demoForm, updateDelegate, statusChangeDelegate));
            
            SimpleTableInfo tableInfo = new SimpleTableInfo(
                "item1 item2 item3",
                "MERGE",
                "equipName status",
                true);
            tableInfo.SetRange(1, 30);

            client.SubscribeTable(
                tableInfo,
                new NmsSimpleTableListener(demoForm, updateDelegate, statusChangeDelegate));
        }
    }

}
