/*
* Copyright (c) 2004-2006 Weswit s.r.l., Via Campanini, 6 - 20124 Milano, Italy.
* All rights reserved.
* www.lightstreamer.com
*
* This software is the confidential and proprietary information of
* Weswit s.r.l.
* You shall not disclose such Confidential Information and shall use it
* only in accordance with the terms of the license agreement you entered
* into with Weswit s.r.l.
*/

using System;
using System.Collections.Generic;
using System.Text;

using Lightstreamer.DotNet.Client;

namespace Nms.DotNet.Client.Demo {

    class NmsSimpleTableListener : ISimpleTableListener {
        private DemoForm demoForm;
        private LightstreamerUpdateDelegate updateDelegate;
        private LightstreamerStatusChangedDelegate statusChangeDelegate;

        public NmsSimpleTableListener(
                DemoForm form,
                LightstreamerUpdateDelegate lsUpdateDelegate,
                LightstreamerStatusChangedDelegate lsStatusChangeDelegate) {
            
            demoForm = form;
            updateDelegate = lsUpdateDelegate;
            statusChangeDelegate = lsStatusChangeDelegate;
        }

        public void OnUpdate(int item, string[] values) {
            demoForm.Invoke(updateDelegate, new Object[] { item, values });
        }

        public void OnRawUpdatesLost(int item, int lostUpdates) {
            string status = "Lost " + lostUpdates + " updates for " + item;
            demoForm.Invoke(statusChangeDelegate, new Object[] { status });
        }

        public void OnSnapshotEnd(int item) {
            string status = "End of snapshot for " + item;
            demoForm.Invoke(statusChangeDelegate, new Object[] { status });
        }

        public void OnUnsubscrAll() {
            string status = "Unsubscr table";
            demoForm.Invoke(statusChangeDelegate, new Object[] { status });
        }
    }

}

